#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <fitsio.h> 

int main(int argc, char **argv){
 fitsfile *fptr;
 int status,colnum_TIME,colnum_MAG,i;
 int colnum_TIME_type,colnum_MAG_type;
 long num_rows;
 int num_cols;
 double *mag;
 double *JD;
 if( argc<2 ){
  fprintf(stderr,"Usage: ./OMC2ASCII XXXX.fit\n");
  exit(1);
 }
 status=0;
 fits_open_table( &fptr, argv[1], READONLY, &status);
 if( status!=0 ){
  fits_report_error(stderr, status);
  exit(status);
 }
 fits_get_num_rows(fptr, &num_rows, &status);
 if( status!=0 ){
  fits_report_error(stderr, status);
  exit(status);
 }
 fits_get_num_cols(fptr, &num_cols, &status);
 if( status!=0 ){
  fits_report_error(stderr, status);
  exit(status);
 }
 fprintf(stderr,"rows: %ld  col:%d\n",num_rows,num_cols);
 fits_get_colnum(fptr, CASEINSEN, "BARYTIME", &colnum_TIME, &status);
 if( status!=0 ){
  fits_report_error(stderr, status);
  exit(status);
 }
 fits_get_coltype(fptr, colnum_TIME, &colnum_TIME_type, NULL, NULL, &status);
 if( status!=0 ){
  fits_report_error(stderr, status);
  exit(status);
 }
 fits_get_colnum(fptr, CASEINSEN, "MAG_V", &colnum_MAG, &status);
 if( status!=0 ){
  fits_report_error(stderr, status);
  exit(status);
 }
 fits_get_coltype(fptr, colnum_MAG, &colnum_MAG_type, NULL, NULL, &status);
 if( status!=0 ){
  fits_report_error(stderr, status);
  exit(status);
 }
 fprintf(stderr," %d (%d) %d (%d)\n",colnum_TIME, colnum_TIME_type, colnum_MAG, colnum_MAG_type);
 mag=malloc(num_rows*sizeof(double));
 if( mag==NULL ){fprintf(stderr,"ERROR allocating memory\n");exit(1);}
 JD=malloc(num_rows*sizeof(double));
 if( JD==NULL ){fprintf(stderr,"ERROR allocating memory\n");exit(1);}
 fits_read_col(fptr, TDOUBLE, colnum_TIME, 1, 1, num_rows, NULL, JD, NULL, &status);
 if( status!=0 ){
  fits_report_error(stderr, status);
  exit(status);
 }
 fits_read_col(fptr, TDOUBLE, colnum_MAG, 1, 1, num_rows, NULL, mag, NULL, &status);
 if( status!=0 ){
  fits_report_error(stderr, status);
  exit(status);
 }
 fits_close_file(fptr, &status);
 if( status!=0 ){
  fits_report_error(stderr, status);
  exit(status);
 }
 for(i=0;i<num_rows;i++){
  fprintf(stdout,"%lf %lf\r\n",JD[i]+2451544.5,mag[i]);
 }
 free(mag);
 free(JD);
 return 0;
}
